{-# OPTIONS_GHC -fglasgow-exts #-}

module Ta where {

import qualified Nat;

data Ta_rule a b = Rule a b [a] deriving (Read, Show);

lhs :: forall a b. Ta_rule a b -> a;
lhs (Rule q l qs) = q;

leta :: forall a b. a -> (a -> b) -> b;
leta s f = f s;

hd :: forall a. [a] -> a;
hd (x : xs) = x;

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x : xs) = xs;

suc :: Nat.Nat -> Nat.Nat;
suc n = n + 1;

rhsl :: forall a b. Ta_rule a b -> b;
rhsl (Rule q l qs) = l;

rhsq :: forall a b. Ta_rule a b -> [a];
rhsq (Rule q l qs) = qs;

data Ustate_wrapper a b = USW1 a | USW2 b deriving (Read, Show);

mapa :: forall a b. (a -> b) -> [a] -> [b];
mapa f [] = [];
mapa f (x : xs) = f x : mapa f xs;

folda :: forall a b. (a -> b -> b) -> [a] -> b -> b;
folda f [] = id;
folda f (x : xs) = folda f xs . f x;

rev :: forall a. [a] -> [a];
rev xs = folda (\ a b -> a : b) xs [];

zipa :: forall a b. [a] -> [b] -> [(a, b)];
zipa (x : xs) (y : ys) = (x, y) : zipa xs ys;
zipa xs [] = [];
zipa [] ys = [];

data Tree a = Node a [Tree a] deriving (Read, Show);

nulla :: forall a. [a] -> Bool;
nulla [] = True;
nulla (x : xs) = False;

revg :: forall a. [a] -> [a] -> [a];
revg [] b = b;
revg (a : asa) b = revg asa (a : b);

r_prod :: forall a b c d. Ta_rule a b -> Ta_rule c d -> Ta_rule (a, c) b;
r_prod (Rule q1 l1 qs1) (Rule q2 l2 qs2) = Rule (q1, q2) l1 (zipa qs1 qs2);

class Orda a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

instance Orda Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

foldla :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldla f a [] = a;
foldla f a (x : xs) = foldla f (f a x) xs;

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

the :: forall a. Maybe a -> a;
the (Just x) = x;

data Color = R | B deriving (Read, Show);

inj_image_filter_cp ::
  forall a b c d e f.
    ((a -> b -> b) -> c -> b -> b) ->
      ((d -> b -> b) -> e -> b -> b) ->
        b -> (f -> b -> b) -> (a -> d -> f) -> (a -> d -> Bool) -> c -> e -> b;
inj_image_filter_cp iterate1 iterate2 empty3 insert_dj3 f p s1 s2 =
  iterate1
    (\ x ->
      iterate2 (\ y res -> (if p x y then insert_dj3 (f x y) res else res)) s2)
    s1
    empty3;

cart ::
  forall a b c d e.
    ((a -> b -> b) -> c -> b -> b) ->
      ((d -> b -> b) -> e -> b -> b) -> b -> ((a, d) -> b -> b) -> c -> e -> b;
cart it1 it2 empty3 ins3 s1 s2 =
  inj_image_filter_cp it1 it2 empty3 ins3 (\ a b -> (a, b)) (\ _ _ -> True) s1
    s2;

member :: forall a. (Eq a) => [a] -> a -> Bool;
member [] y = False;
member (x : xs) y = x == y || member xs y;

data Rbt a b = Empty | Branch Color (Rbt a b) a b (Rbt a b)
  deriving (Read, Show);

data Tuple_isomorphism a b c = Tuple_Isomorphism (a -> (b, c)) ((b, c) -> a);

abst :: forall a b c. Tuple_isomorphism a b c -> (b, c) -> a;
abst (Tuple_Isomorphism r a) = a;

repr :: forall a b c. Tuple_isomorphism a b c -> a -> (b, c);
repr (Tuple_Isomorphism r a) = r;

class (Orda a) => Preorder a where {
};

instance Preorder Integer where {
};

class (Preorder a) => Order a where {
};

instance Order Integer where {
};

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if member xs x then remdups xs else x : remdups xs);

it_add ::
  forall a b c.
    (a -> b -> c -> c) -> ((a -> b -> c -> c) -> c -> c -> c) -> c -> c -> c;
it_add update iteratea m1 m2 = iteratea update m2 m1;

balance :: forall a b. Rbt a b -> a -> b -> Rbt a b -> Rbt a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Empty =
  Branch R (Branch B a w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Empty w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch R Empty w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Empty w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Empty w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance Empty w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Empty s t Empty = Branch B Empty s t Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance Empty s t (Branch B va vb vc Empty) =
  Branch B Empty s t (Branch B va vb vc Empty);
balance Empty s t (Branch v Empty vb vc Empty) =
  Branch B Empty s t (Branch v Empty vb vc Empty);
balance Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty) =
  Branch B Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty);
balance Empty s t (Branch B va vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch B va vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi))
  = Branch B Empty s t
      (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch B ve vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v (Branch B vi vj vk vl) vf vg Empty)
  = Branch B (Branch B va vb vc vd) s t
      (Branch v (Branch B vi vj vk vl) vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch B ve vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch B ve vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg (Branch B vj vk vl vm))
  = Branch B (Branch B va vb vc vd) s t
      (Branch v Empty vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance Empty s t Empty = Branch B Empty s t Empty;
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B Empty vb vc vd) s t Empty =
  Branch B (Branch B Empty vb vc vd) s t Empty;
balance (Branch v Empty vb vc Empty) s t Empty =
  Branch B (Branch v Empty vb vc Empty) s t Empty;
balance (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty =
  Branch B (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty;
balance (Branch B (Branch B vf vg vh vi) vb vc vd) s t Empty =
  Branch B (Branch B (Branch B vf vg vh vi) vb vc vd) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t Empty
  = Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
      Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance (Branch B ve vf vg vh) s t (Branch B va vb vc vd) =
  Branch B (Branch B ve vf vg vh) s t (Branch B va vb vc vd);
balance (Branch B Empty vf vg vh) s t (Branch B va vb vc vd) =
  Branch B (Branch B Empty vf vg vh) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd) =
  Branch B (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg (Branch B vi vj vk vl)) s t (Branch B va vb vc vd)
  = Branch B (Branch v Empty vf vg (Branch B vi vj vk vl)) s t
      (Branch B va vb vc vd);
balance (Branch B (Branch B vj vk vl vm) vf vg vh) s t (Branch B va vb vc vd) =
  Branch B (Branch B (Branch B vj vk vl vm) vf vg vh) s t
    (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Empty) s t (Branch B va vb vc vd)
  = Branch B (Branch v (Branch B vj vk vl vm) vf vg Empty) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

class (Order a) => Linorder a where {
};

ins ::
  forall a b.
    (Linorder a) => (a -> b -> b -> b) -> a -> b -> Rbt a b -> Rbt a b;
ins f k v Empty = Branch R Empty k v Empty;
ins f k v (Branch B l x y r) =
  (if less k x then balance (ins f k v l) x y r
    else (if less x k then balance l x y (ins f k v r)
           else Branch B l x (f k y v) r));
ins f k v (Branch R l x y r) =
  (if less k x then Branch R (ins f k v l) x y r
    else (if less x k then Branch R l x y (ins f k v r)
           else Branch R l x (f k y v) r));

eq_ta_rule :: forall a b. (Eq a, Eq b) => Ta_rule a b -> Ta_rule a b -> Bool;
eq_ta_rule (Rule qa la lista) (Rule q l list) =
  qa == q && (la == l && lista == list);

instance (Eq a, Eq b) => Eq (Ta_rule a b) where {
  a == b = eq_ta_rule a b;
};

list_case :: forall a b. a -> (b -> [b] -> a) -> [b] -> a;
list_case f1 f2 (a : list) = f2 a list;
list_case f1 f2 [] = f1;

fifo_get :: forall a. ([a], [a]) -> (a, ([a], [a]));
fifo_get f =
  (case snd f of {
    [] -> let {
            rp = rev (fst f);
          } in (hd rp, ([], tl rp));
    a : l -> (a, (fst f, l));
  });

fifo_put :: forall a. a -> ([a], [a]) -> ([a], [a]);
fifo_put a f = (a : fst f, snd f);

list_all :: forall a. (a -> Bool) -> [a] -> Bool;
list_all p [] = True;
list_all p (x : xs) = p x && list_all p xs;

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

iti_sel ::
  forall a b c d e f g.
    ((Maybe a -> Bool) ->
      (b -> c -> d -> Maybe e) -> f -> Maybe g -> Maybe e) ->
      f -> (b -> c -> Maybe e) -> Maybe e;
iti_sel iti m f = iti is_none (\ k v _ -> f k v) m Nothing;

map_sng :: forall a b c. a -> (b -> c -> a -> a) -> b -> c -> a;
map_sng empt update k v = update k v empt;

fold :: forall a b c. (a -> b -> c -> c) -> Rbt a b -> c -> c;
fold f (Branch c lt k v rt) = (fold f rt . f k v) . fold f lt;
fold f Empty = id;

it_size ::
  forall a b.
    ((a -> Nat.Nat -> Nat.Nat) -> b -> Nat.Nat -> Nat.Nat) -> b -> Nat.Nat;
it_size iteratea s = iteratea (\ _ -> suc) s 0;

remap_rule :: forall a b c. (a -> b) -> Ta_rule a c -> Ta_rule b c;
remap_rule f (Rule q l qs) = Rule (f q) l (mapa f qs);

newtype HashedTa_ext_type a b c = Abs_hashedTa_ext_type
  (((Rbt Integer [(a, ())], [Ta_rule a b]),
     (Maybe (Rbt Integer [(b, [Ta_rule a b])]),
       (Maybe (Rbt Integer [(a, [Ta_rule a b])]),
         Maybe (Rbt Integer [((a, b), [Ta_rule a b])])))),
    c)
  deriving (Read, Show);

rep_hashedTa_ext_type ::
  forall a b c.
    HashedTa_ext_type a b c ->
      (((Rbt Integer [(a, ())], [Ta_rule a b]),
         (Maybe (Rbt Integer [(b, [Ta_rule a b])]),
           (Maybe (Rbt Integer [(a, [Ta_rule a b])]),
             Maybe (Rbt Integer [((a, b), [Ta_rule a b])])))),
        c);
rep_hashedTa_ext_type (Abs_hashedTa_ext_type y) = y;

hashedTa_ext_type_Tuple_Iso ::
  forall a b c.
    Tuple_isomorphism (HashedTa_ext_type a b c)
      ((Rbt Integer [(a, ())], [Ta_rule a b]),
        (Maybe (Rbt Integer [(b, [Ta_rule a b])]),
          (Maybe (Rbt Integer [(a, [Ta_rule a b])]),
            Maybe (Rbt Integer [((a, b), [Ta_rule a b])]))))
      c;
hashedTa_ext_type_Tuple_Iso =
  Tuple_Isomorphism rep_hashedTa_ext_type Abs_hashedTa_ext_type;

iso_tuple_snd :: forall a b c. Tuple_isomorphism a b c -> a -> c;
iso_tuple_snd isom = snd . repr isom;

tuple_iso_tuple :: forall a b. Tuple_isomorphism (a, b) a b;
tuple_iso_tuple = Tuple_Isomorphism id id;

iso_tuple_fst :: forall a b c. Tuple_isomorphism a b c -> a -> b;
iso_tuple_fst isom = fst . repr isom;

hta_idx_f ::
  forall a b c.
    HashedTa_ext_type a b c -> Maybe (Rbt Integer [(b, [Ta_rule a b])]);
hta_idx_f =
  ((id . iso_tuple_fst tuple_iso_tuple) . iso_tuple_snd tuple_iso_tuple) .
    iso_tuple_fst hashedTa_ext_type_Tuple_Iso;

ls_empty :: forall a. [a];
ls_empty = [];

class Hashable a where {
  hashcode :: a -> Integer;
};

instance Linorder Integer where {
};

lookupa :: forall a b. (Linorder a) => Rbt a b -> a -> Maybe b;
lookupa Empty k = Nothing;
lookupa (Branch uu l x y r) k =
  (if less k x then lookupa l k
    else (if less x k then lookupa r k else Just y));

rm_lookup :: forall a b. (Linorder a) => a -> Rbt a b -> Maybe b;
rm_lookup k m = lookupa m k;

lm_lookup :: forall a b. (Eq a) => a -> [(a, b)] -> Maybe b;
lm_lookup k m = map_of m k;

option_case :: forall a b. a -> (b -> a) -> Maybe b -> a;
option_case f1 f2 (Just a) = f2 a;
option_case f1 f2 Nothing = f1;

hm_lookup ::
  forall a b. (Eq a, Hashable a) => a -> Rbt Integer [(a, b)] -> Maybe b;
hm_lookup k m =
  (case rm_lookup (hashcode k) m of {
    Nothing -> Nothing;
    Just a -> lm_lookup k a;
  });

idx_lookup :: forall a b c. (a -> b -> Maybe c) -> c -> a -> b -> c;
idx_lookup mlookup tempty i m =
  (case mlookup i m of {
    Nothing -> tempty;
    Just s -> s;
  });

hl_idx_lookup ::
  forall a b. (Eq a, Hashable a) => a -> Rbt Integer [(a, [b])] -> [b];
hl_idx_lookup = idx_lookup hm_lookup ls_empty;

hta_lookup_f ::
  forall a b c.
    (Eq a, Hashable a) => a -> HashedTa_ext_type b a c -> [Ta_rule b a];
hta_lookup_f f h = hl_idx_lookup f (the (hta_idx_f h));

ls_memb :: forall a. (Eq a) => a -> [a] -> Bool;
ls_memb = (\ x xs -> member xs x);

list_all_zip :: forall a b. (a -> b -> Bool) -> [a] -> [b] -> Bool;
list_all_zip p [] [] = True;
list_all_zip p (a : asa) (b : bs) = p a b && list_all_zip p asa bs;
list_all_zip p (v : va) [] = False;
list_all_zip p [] (v : va) = False;

ta_rule_case :: forall a b c. (a -> b -> [a] -> c) -> Ta_rule a b -> c;
ta_rule_case f1 (Rule q l list) = f1 q l list;

ls_ins :: forall a. (Eq a) => a -> [a] -> [a];
ls_ins x l = (if member l x then l else x : l);

ls_iteratei :: forall a b. (a -> Bool) -> (b -> a -> a) -> [b] -> a -> a;
ls_iteratei c f [] sigma = sigma;
ls_iteratei c f (x : l) sigma =
  (if c sigma then ls_iteratei c f l (f x sigma) else sigma);

iti_iterate ::
  forall a b c.
    ((a -> Bool) -> (b -> a -> a) -> c -> a -> a) ->
      (b -> a -> a) -> c -> a -> a;
iti_iterate iti = iti (\ _ -> True);

ls_iterate :: forall a b. (a -> b -> b) -> [a] -> b -> b;
ls_iterate = iti_iterate ls_iteratei;

it_image_filter ::
  forall a b c d.
    ((a -> b -> b) -> c -> b -> b) ->
      b -> (d -> b -> b) -> (a -> Maybe d) -> c -> b;
it_image_filter iterate1 empty2 ins2 f s =
  iterate1 (\ x res -> (case f x of {
                         Nothing -> res;
                         Just v -> ins2 v res;
                       }))
    s
    empty2;

ls_image_filter :: forall a b. (Eq b) => (a -> Maybe b) -> [a] -> [b];
ls_image_filter = it_image_filter ls_iterate ls_empty ls_ins;

faccs ::
  forall a b c.
    (Eq a, Eq b, Hashable b) => HashedTa_ext_type a b c -> Tree b -> [a];
faccs h (Node f ts) =
  let {
    qs = mapa (faccs h) ts;
  } in ls_image_filter
         (\ r ->
           let {
             (Rule _ _ qsa) = r;
           } in (if list_all_zip (\ q qa -> ls_memb qa q) qs qsa
                  then Just (lhs r) else Nothing))
         (hta_lookup_f f h);

lm_iterate_code :: forall a b c. (a -> b -> c -> c) -> [(a, b)] -> c -> c;
lm_iterate_code f [] sigma = sigma;
lm_iterate_code f ((k, v) : l) sigma = lm_iterate_code f l (f k v sigma);

lm_iterate :: forall a b c. (a -> b -> c -> c) -> [(a, b)] -> c -> c;
lm_iterate = lm_iterate_code;

rm_iterate :: forall a b c. (a -> b -> c -> c) -> Rbt a b -> c -> c;
rm_iterate = fold;

hm_iterate :: forall a b c d. (a -> b -> c -> c) -> Rbt d [(a, b)] -> c -> c;
hm_iterate f m sigma_0 = rm_iterate (\ _ -> lm_iterate f) m sigma_0;

update :: forall a b. (Eq a) => a -> b -> [(a, b)] -> [(a, b)];
update k v [] = [(k, v)];
update k v (p : ps) = (if fst p == k then (k, v) : ps else p : update k v ps);

lm_update :: forall a b. (Eq a) => a -> b -> [(a, b)] -> [(a, b)];
lm_update = update;

lm_empty :: forall a. [a];
lm_empty = [];

lm_sng :: forall a b. (Eq a) => a -> b -> [(a, b)];
lm_sng = map_sng lm_empty lm_update;

paint :: forall a b. Color -> Rbt a b -> Rbt a b;
paint c Empty = Empty;
paint c (Branch uu l k v r) = Branch c l k v r;

insert_with_key ::
  forall a b.
    (Linorder a) => (a -> b -> b -> b) -> a -> b -> Rbt a b -> Rbt a b;
insert_with_key f k v t = paint B (ins f k v t);

insert :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
insert = insert_with_key (\ _ _ nv -> nv);

rm_update :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
rm_update = insert;

hm_update ::
  forall a b.
    (Eq a,
      Hashable a) => a -> b -> Rbt Integer [(a, b)] -> Rbt Integer [(a, b)];
hm_update k v m =
  let {
    hc = hashcode k;
  } in (case rm_lookup hc m of {
         Nothing -> rm_update hc (lm_sng k v) m;
         Just bm -> rm_update hc (lm_update k v bm) m;
       });

hm_add ::
  forall a b.
    (Eq a,
      Hashable a) => Rbt Integer [(a, b)] ->
                       Rbt Integer [(a, b)] -> Rbt Integer [(a, b)];
hm_add = it_add hm_update hm_iterate;

lm_iteratei ::
  forall a b c. (a -> Bool) -> (b -> c -> a -> a) -> [(b, c)] -> a -> a;
lm_iteratei c f [] sigma = sigma;
lm_iteratei c f ((k, v) : l) sigma =
  (if c sigma then lm_iteratei c f l (f k v sigma) else sigma);

lm_sel :: forall a b c. [(a, b)] -> (a -> b -> Maybe c) -> Maybe c;
lm_sel = iti_sel lm_iteratei;

rm_iteratei ::
  forall a b c. (a -> Bool) -> (b -> c -> a -> a) -> Rbt b c -> a -> a;
rm_iteratei c f Empty sigma = sigma;
rm_iteratei c f (Branch col l k v r) sigma =
  (if c sigma then rm_iteratei c f l (rm_iteratei c f r (f k v sigma))
    else sigma);

rm_sel :: forall a b c. Rbt a b -> (a -> b -> Maybe c) -> Maybe c;
rm_sel = iti_sel rm_iteratei;

hm_sel ::
  forall a b c.
    (Hashable a) => Rbt Integer [(a, b)] -> (a -> b -> Maybe c) -> Maybe c;
hm_sel m f = rm_sel m (\ _ lm -> lm_sel lm f);

s_ins :: forall a b c. (a -> () -> b -> c) -> a -> b -> c;
s_ins update x s = update x () s;

hs_ins ::
  forall a.
    (Eq a, Hashable a) => a -> Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_ins = s_ins hm_update;

s_sel ::
  forall a b c.
    (a -> (b -> () -> Maybe c) -> Maybe c) -> a -> (b -> Maybe c) -> Maybe c;
s_sel sel s f = sel s (\ u _ -> f u);

hs_sel ::
  forall a b.
    (Hashable a) => Rbt Integer [(a, ())] -> (a -> Maybe b) -> Maybe b;
hs_sel = s_sel hm_sel;

size_list :: forall a. [a] -> Nat.Nat;
size_list [] = 0;
size_list (a : list) = size_list list + suc 0;

it_inter ::
  forall a b c d.
    ((a -> b -> b) -> c -> b -> b) ->
      (a -> d -> Bool) -> b -> (a -> b -> b) -> c -> d -> b;
it_inter iterate1 memb2 empt3 insrt3 s1 s2 =
  iterate1 (\ x s -> (if memb2 x s2 then insrt3 x s else s)) s1 empt3;

it_union ::
  forall a b c. ((a -> b -> b) -> c -> b -> b) -> (a -> b -> b) -> c -> b -> b;
it_union iterate1 insrt2 s1 s2 = iterate1 insrt2 s1 s2;

rm_empty :: forall a b. Rbt a b;
rm_empty = Empty;

hm_empty :: forall a b. Rbt a b;
hm_empty = rm_empty;

s_empty :: forall a. a -> a;
s_empty empt = empt;

hs_empty :: forall a. (Hashable a) => Rbt Integer [(a, ())];
hs_empty = s_empty hm_empty;

lh_image_filter ::
  forall a b.
    (Eq b, Hashable b) => (a -> Maybe b) -> [a] -> Rbt Integer [(b, ())];
lh_image_filter = it_image_filter ls_iterate hs_empty hs_ins;

brc_iq ::
  forall a b. (Eq a, Hashable a) => [Ta_rule a b] -> Rbt Integer [(a, ())];
brc_iq delta =
  lh_image_filter (\ r -> (if nulla (rhsq r) then Just (lhs r) else Nothing))
    delta;

hta_Qi :: forall a b c. HashedTa_ext_type a b c -> Rbt Integer [(a, ())];
hta_Qi =
  ((id . iso_tuple_fst tuple_iso_tuple) . iso_tuple_fst tuple_iso_tuple) .
    iso_tuple_fst hashedTa_ext_type_Tuple_Iso;

fifo_empty :: forall a. ([a], [a]);
fifo_empty = ([], []);

s_memb :: forall a b c. (a -> b -> Maybe c) -> a -> b -> Bool;
s_memb lookupa x s = not (is_none (lookupa x s));

hs_memb :: forall a. (Eq a, Hashable a) => a -> Rbt Integer [(a, ())] -> Bool;
hs_memb = s_memb hm_lookup;

s_iterate ::
  forall a b c d e f g.
    ((a -> b -> c -> d) -> e -> f -> g) -> (a -> c -> d) -> e -> f -> g;
s_iterate iteratea f s sigma_0 = iteratea (\ k _ -> f k) s sigma_0;

hs_iterate ::
  forall a b. (Hashable a) => (a -> b -> b) -> Rbt Integer [(a, ())] -> b -> b;
hs_iterate = s_iterate hm_iterate;

hs_size :: forall a. (Hashable a) => Rbt Integer [(a, ())] -> Nat.Nat;
hs_size = it_size hs_iterate;

hta_delta :: forall a b c. HashedTa_ext_type a b c -> [Ta_rule a b];
hta_delta =
  ((id . iso_tuple_snd tuple_iso_tuple) . iso_tuple_fst tuple_iso_tuple) .
    iso_tuple_fst hashedTa_ext_type_Tuple_Iso;

idx_build_stepfun ::
  forall a b c d.
    (a -> b -> Maybe c) ->
      (a -> c -> b -> b) -> c -> (d -> c -> c) -> (d -> a) -> d -> b -> b;
idx_build_stepfun mlookup mupdate tempty tinsert f x m =
  let {
    i = f x;
  } in (case mlookup i m of {
         Nothing -> mupdate i (tinsert x tempty) m;
         Just s -> mupdate i (tinsert x s) m;
       });

idx_build ::
  forall a b c d e.
    a -> (b -> a -> Maybe c) ->
           (b -> c -> a -> a) ->
             c -> (d -> c -> c) ->
                    ((d -> a -> a) -> e -> a -> a) -> (d -> b) -> e -> a;
idx_build mempty mlookup mupdate tempty tinsert siterate f s =
  siterate (idx_build_stepfun mlookup mupdate tempty tinsert f) s mempty;

hll_idx_build ::
  forall a b.
    (Eq a, Eq b, Hashable b) => (a -> b) -> [a] -> Rbt Integer [(b, [a])];
hll_idx_build =
  idx_build hm_empty hm_lookup hm_update ls_empty ls_ins ls_iterate;

build_rule_index ::
  forall a b c.
    (Eq a, Eq b, Eq c,
      Hashable c) => (Ta_rule a b -> c) ->
                       [Ta_rule a b] -> Rbt Integer [(c, [Ta_rule a b])];
build_rule_index = hll_idx_build;

build_rule_index_f ::
  forall a b.
    (Eq a, Eq b,
      Hashable b) => [Ta_rule a b] -> Rbt Integer [(b, [Ta_rule a b])];
build_rule_index_f delta = build_rule_index rhsl delta;

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

iso_tuple_snd_update ::
  forall a b c. Tuple_isomorphism a b c -> (c -> c) -> a -> a;
iso_tuple_snd_update isom f = (abst isom . apsnd f) . repr isom;

apfst :: forall a b c. (a -> b) -> (a, c) -> (b, c);
apfst f (x, y) = (f x, y);

iso_tuple_fst_update ::
  forall a b c. Tuple_isomorphism a b c -> (b -> b) -> a -> a;
iso_tuple_fst_update isom f = (abst isom . apfst f) . repr isom;

hta_idx_f_update ::
  forall a b c.
    (Maybe (Rbt Integer [(a, [Ta_rule b a])]) ->
      Maybe (Rbt Integer [(a, [Ta_rule b a])])) ->
      HashedTa_ext_type b a c -> HashedTa_ext_type b a c;
hta_idx_f_update =
  iso_tuple_fst_update hashedTa_ext_type_Tuple_Iso .
    iso_tuple_snd_update tuple_iso_tuple .
      iso_tuple_fst_update tuple_iso_tuple . id;

hta_ensure_idx_f ::
  forall a b c.
    (Eq a, Eq b,
      Hashable b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_ensure_idx_f h =
  (case hta_idx_f h of {
    Nothing ->
      hta_idx_f_update (\ _ -> Just (build_rule_index_f (hta_delta h))) h;
    Just _ -> h;
  });

ls_ball :: forall a. [a] -> (a -> Bool) -> Bool;
ls_ball l p = list_all p l;

ball_disjoint ::
  forall a b c d. (a -> (b -> Bool) -> c) -> (b -> d -> Bool) -> a -> d -> c;
ball_disjoint ball1 memb2 s1 s2 = ball1 s1 (\ x -> not (memb2 x s2));

lh_disjoint ::
  forall a. (Eq a, Hashable a) => [a] -> Rbt Integer [(a, ())] -> Bool;
lh_disjoint = ball_disjoint ls_ball hs_memb;

hta_mema ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext_type b a c -> Bool;
hta_mema t h = not (lh_disjoint (faccs h t) (hta_Qi h));

hta_mem ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext_type b a c -> Bool;
hta_mem t h = hta_mema t (hta_ensure_idx_f h);

split :: forall a b c. (a -> b -> c) -> (a, b) -> c;
split f (a, b) = f a b;

pa_cond ::
  forall a b c.
    (Hashable a, Hashable b,
      Hashable c) => (Rbt Integer [((a, b), ())],
                       ([(a, b)], [Ta_rule (a, b) c])) ->
                       Bool;
pa_cond s = let {
              (_, (w, _)) = s;
            } in not (nulla w);

hta_idx_s ::
  forall a b c.
    HashedTa_ext_type a b c -> Maybe (Rbt Integer [(a, [Ta_rule a b])]);
hta_idx_s =
  (((id . iso_tuple_fst tuple_iso_tuple) . iso_tuple_snd tuple_iso_tuple) .
    iso_tuple_snd tuple_iso_tuple) .
    iso_tuple_fst hashedTa_ext_type_Tuple_Iso;

hta_lookup_s ::
  forall a b c.
    (Eq a, Hashable a) => a -> HashedTa_ext_type a b c -> [Ta_rule a b];
hta_lookup_s q h = hl_idx_lookup q (the (hta_idx_s h));

hta_idx_sf ::
  forall a b c.
    HashedTa_ext_type a b c -> Maybe (Rbt Integer [((a, b), [Ta_rule a b])]);
hta_idx_sf =
  (((id . iso_tuple_snd tuple_iso_tuple) . iso_tuple_snd tuple_iso_tuple) .
    iso_tuple_snd tuple_iso_tuple) .
    iso_tuple_fst hashedTa_ext_type_Tuple_Iso;

prod_case :: forall a b c. (a -> b -> c) -> (a, b) -> c;
prod_case f1 (a, b) = f1 a b;

hashcodea :: forall a b. (Hashable a, Hashable b) => (a, b) -> Integer;
hashcodea x = let {
                (a, b) = x;
              } in hashcode a + hashcode b;

instance (Hashable a, Hashable b) => Hashable (a, b) where {
  hashcode = hashcodea;
};

hta_lookup_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => a -> b -> HashedTa_ext_type a b c -> [Ta_rule a b];
hta_lookup_sf q f h = hl_idx_lookup (q, f) (the (hta_idx_sf h));

ls_ins_dj :: forall a. a -> [a] -> [a];
ls_ins_dj x l = x : l;

pa_upd_rule ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [((a, b), ())] ->
                       [(a, b)] ->
                         [(a, b)] -> (Rbt Integer [((a, b), ())], [(a, b)]);
pa_upd_rule q w [] = (q, w);
pa_upd_rule q w (qp : qs) =
  (if not (hs_memb qp q) then pa_upd_rule (hs_ins qp q) (qp : w) qs
    else pa_upd_rule q w qs);

pa_step ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext_type a b () ->
                       HashedTa_ext_type c b () ->
                         (Rbt Integer [((a, c), ())],
                           ([(a, c)], [Ta_rule (a, c) b])) ->
                           (Rbt Integer [((a, c), ())],
                             ([(a, c)], [Ta_rule (a, c) b]));
pa_step h1 h2 s =
  let {
    (q, (w, delta_d)) = s;
    (q1, q2) = hd w;
  } in ls_iterate
         (\ r1 ->
           ls_iterate
             (\ r2 res ->
               (if size_list (rhsq r1) == size_list (rhsq r2)
                 then let {
                        rp = r_prod r1 r2;
                        (qa, (wa, delta_da)) = res;
                        (qb, wb) = pa_upd_rule qa wa (rhsq rp);
                      } in (qb, (wb, ls_ins_dj rp delta_da))
                 else res))
             (hta_lookup_sf q2 (rhsl r1) h2))
         (hta_lookup_s q1 h1) (q, (tl w, delta_d));

map_to_nat ::
  forall a b c.
    ((a -> (Nat.Nat, b) -> (Nat.Nat, b)) ->
      c -> (Nat.Nat, b) -> (Nat.Nat, b)) ->
      b -> (a -> Nat.Nat -> b -> b) -> c -> b;
map_to_nat iterate1 empty2 update2 s =
  snd (iterate1 (\ x (c, m) -> (c + 1, update2 x c m)) s (0, empty2));

hs_image_filter ::
  forall a b.
    (Hashable a, Eq b,
      Hashable b) => (a -> Maybe b) ->
                       Rbt Integer [(a, ())] -> Rbt Integer [(b, ())];
hs_image_filter = it_image_filter hs_iterate hs_empty hs_ins;

iflt_image :: forall a b c d. ((a -> Maybe b) -> c -> d) -> (a -> b) -> c -> d;
iflt_image iflt f s = iflt (\ x -> Just (f x)) s;

hs_image ::
  forall a b.
    (Hashable a, Eq b,
      Hashable b) => (a -> b) -> Rbt Integer [(a, ())] -> Rbt Integer [(b, ())];
hs_image = iflt_image hs_image_filter;

hm_update_dj ::
  forall a b.
    (Eq a,
      Hashable a) => a -> b -> Rbt Integer [(a, b)] -> Rbt Integer [(a, b)];
hm_update_dj = hm_update;

s_ins_dj :: forall a b c. (a -> () -> b -> c) -> a -> b -> c;
s_ins_dj update_dj x s = update_dj x () s;

hs_ins_dj ::
  forall a.
    (Eq a, Hashable a) => a -> Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_ins_dj = s_ins_dj hm_update_dj;

hs_inter ::
  forall a.
    (Eq a,
      Hashable a) => Rbt Integer [(a, ())] ->
                       Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_inter = it_inter hs_iterate hs_memb hs_empty hs_ins_dj;

s_union :: forall a. a -> a;
s_union add = add;

hs_union ::
  forall a.
    (Eq a,
      Hashable a) => Rbt Integer [(a, ())] ->
                       Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
hs_union = s_union hm_add;

hhh_cart ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [(a, ())] ->
                       Rbt Integer [(b, ())] -> Rbt Integer [((a, b), ())];
hhh_cart = cart hs_iterate hs_iterate hs_empty hs_ins_dj;

brc_cond ::
  forall a b.
    (Hashable a,
      Hashable b) => (Rbt Integer [(a, ())],
                       ([a], Rbt Integer [(Ta_rule a b, Nat.Nat)])) ->
                       Bool;
brc_cond = (\ (_, (w, _)) -> not (nulla w));

rqrm_lookup ::
  forall a b. (Eq a, Hashable a) => Rbt Integer [(a, [b])] -> a -> [b];
rqrm_lookup rqrm q =
  (case hm_lookup q rqrm of {
    Nothing -> ls_empty;
    Just s -> s;
  });

hashcode_of_list :: forall a. (Hashable a) => [a] -> Integer;
hashcode_of_list [] = 0;
hashcode_of_list (x : xs) = hashcode x + hashcode_of_list xs;

hashcode_list :: forall a. (Hashable a) => [a] -> Integer;
hashcode_list = hashcode_of_list;

hashcode_of_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Ta_rule a b -> Integer;
hashcode_of_ta_rule (Rule q f qs) = hashcode q + hashcode f + hashcode_list qs;

hashcode_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Ta_rule a b -> Integer;
hashcode_ta_rule = hashcode_of_ta_rule;

instance (Hashable a, Hashable b) => Hashable (Ta_rule a b) where {
  hashcode = hashcode_ta_rule;
};

brc_inner_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Ta_rule a b ->
                       (Rbt Integer [(a, ())],
                         ([a], Rbt Integer [(Ta_rule a b, Nat.Nat)])) ->
                         (Rbt Integer [(a, ())],
                           ([a], Rbt Integer [(Ta_rule a b, Nat.Nat)]));
brc_inner_step r =
  (\ (q, (w, rcm)) ->
    let {
      c = the (hm_lookup r rcm);
      rcma = hm_update r (c - 1) rcm;
      qa = (if c <= 1 then hs_ins (lhs r) q else q);
      wa = (if c <= 1 && not (hs_memb (lhs r) q) then lhs r : w else w);
    } in (qa, (wa, rcma)));

brc_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [(a, [Ta_rule a b])] ->
                       (Rbt Integer [(a, ())],
                         ([a], Rbt Integer [(Ta_rule a b, Nat.Nat)])) ->
                         (Rbt Integer [(a, ())],
                           ([a], Rbt Integer [(Ta_rule a b, Nat.Nat)]));
brc_step rqrm =
  (\ (q, (w, rcm)) ->
    ls_iterate brc_inner_step (rqrm_lookup rqrm (hd w)) (q, (tl w, rcm)));

brec_iqm ::
  forall a b.
    (Eq a, Hashable a,
      Hashable b) => [Ta_rule a b] -> Rbt Integer [(a, Tree b)];
brec_iqm delta =
  ls_iterate
    (\ r m ->
      (if nulla (rhsq r) then hm_update (lhs r) (Node (rhsl r) []) m else m))
    delta hm_empty;

build_rule_index_sf ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => [Ta_rule a b] -> Rbt Integer [((a, b), [Ta_rule a b])];
build_rule_index_sf delta = build_rule_index (\ r -> (lhs r, rhsl r)) delta;

hta_idx_sf_update ::
  forall a b c.
    (Maybe (Rbt Integer [((a, b), [Ta_rule a b])]) ->
      Maybe (Rbt Integer [((a, b), [Ta_rule a b])])) ->
      HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_idx_sf_update =
  iso_tuple_fst_update hashedTa_ext_type_Tuple_Iso .
    iso_tuple_snd_update tuple_iso_tuple .
      iso_tuple_snd_update tuple_iso_tuple .
        iso_tuple_snd_update tuple_iso_tuple . id;

hta_ensure_idx_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_ensure_idx_sf h =
  (case hta_idx_sf h of {
    Nothing ->
      hta_idx_sf_update (\ _ -> Just (build_rule_index_sf (hta_delta h))) h;
    Just _ -> h;
  });

build_rule_index_s ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => [Ta_rule a b] -> Rbt Integer [(a, [Ta_rule a b])];
build_rule_index_s delta = build_rule_index lhs delta;

hta_idx_s_update ::
  forall a b c.
    (Maybe (Rbt Integer [(a, [Ta_rule a b])]) ->
      Maybe (Rbt Integer [(a, [Ta_rule a b])])) ->
      HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_idx_s_update =
  iso_tuple_fst_update hashedTa_ext_type_Tuple_Iso .
    iso_tuple_snd_update tuple_iso_tuple .
      iso_tuple_snd_update tuple_iso_tuple .
        iso_tuple_fst_update tuple_iso_tuple . id;

hta_ensure_idx_s ::
  forall a b c.
    (Eq a, Hashable a,
      Eq b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b c;
hta_ensure_idx_s h =
  (case hta_idx_s h of {
    Nothing ->
      hta_idx_s_update (\ _ -> Just (build_rule_index_s (hta_delta h))) h;
    Just _ -> h;
  });

currya :: forall a b c. ((a, b) -> c) -> a -> b -> c;
currya f a b = f (a, b);

iso_tuple_cons :: forall a b c. Tuple_isomorphism a b c -> b -> c -> a;
iso_tuple_cons isom = currya (abst isom);

hashedTa_ext ::
  forall a b c.
    Rbt Integer [(a, ())] ->
      [Ta_rule a b] ->
        Maybe (Rbt Integer [(b, [Ta_rule a b])]) ->
          Maybe (Rbt Integer [(a, [Ta_rule a b])]) ->
            Maybe (Rbt Integer [((a, b), [Ta_rule a b])]) ->
              c -> HashedTa_ext_type a b c;
hashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more =
  iso_tuple_cons hashedTa_ext_type_Tuple_Iso
    (iso_tuple_cons tuple_iso_tuple
      (iso_tuple_cons tuple_iso_tuple hta_Qi hta_delta)
      (iso_tuple_cons tuple_iso_tuple hta_idx_f
        (iso_tuple_cons tuple_iso_tuple hta_idx_s hta_idx_sf)))
    more;

init_hta ::
  forall a b.
    Rbt Integer [(a, ())] -> [Ta_rule a b] -> HashedTa_ext_type a b ();
init_hta qi delta = hashedTa_ext qi delta Nothing Nothing Nothing ();

it_set_to_list ::
  forall a b c. ((a -> [a] -> [a]) -> b -> [c] -> [a]) -> b -> [a];
it_set_to_list iteratea s = iteratea (\ a b -> a : b) s [];

hs_to_list :: forall a. (Hashable a) => Rbt Integer [(a, ())] -> [a];
hs_to_list = it_set_to_list hs_iterate;

pa_initial ::
  forall a b c.
    (Eq a, Hashable a, Hashable b, Eq c,
      Hashable c) => HashedTa_ext_type a b () ->
                       HashedTa_ext_type c b () ->
                         (Rbt Integer [((a, c), ())],
                           ([(a, c)], [Ta_rule (a, c) b]));
pa_initial h1 h2 =
  let {
    qip = hhh_cart (hta_Qi h1) (hta_Qi h2);
  } in (qip, (hs_to_list qip, ls_empty));

while :: forall a. (a -> Bool) -> (a -> a) -> a -> a;
while b c s = (if b s then while b c (c s) else s);

hta_proda ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext_type a b () ->
                       HashedTa_ext_type c b () ->
                         HashedTa_ext_type (a, c) b ();
hta_proda h1 h2 =
  let {
    (_, (_, a)) = while pa_cond (pa_step h1 h2) (pa_initial h1 h2);
  } in init_hta (hhh_cart (hta_Qi h1) (hta_Qi h2)) a;

hta_prod ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext_type a b () ->
                       HashedTa_ext_type c b () ->
                         HashedTa_ext_type (a, c) b ();
hta_prod h1 h2 = hta_proda (hta_ensure_idx_s h1) (hta_ensure_idx_sf h2);

hashcode_nat :: Nat.Nat -> Integer;
hashcode_nat i = toInteger i;

instance Hashable Nat.Nat where {
  hashcode = hashcode_nat;
};

htai_mem :: Tree Nat.Nat -> HashedTa_ext_type Nat.Nat Nat.Nat () -> Bool;
htai_mem = hta_mem;

rqrm_add ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => a -> b -> Rbt Integer [(a, [b])] -> Rbt Integer [(a, [b])];
rqrm_add q r res =
  (case hm_lookup q res of {
    Nothing -> hm_update q (ls_ins r ls_empty) res;
    Just s -> hm_update q (ls_ins r s) res;
  });

fifo_isEmpty :: forall a. (Eq a) => ([a], [a]) -> Bool;
fifo_isEmpty f = f == ([], []);

lhh_union ::
  forall a.
    (Eq a, Hashable a) => [a] -> Rbt Integer [(a, ())] -> Rbt Integer [(a, ())];
lhh_union = it_union ls_iterate hs_ins;

brec_cond ::
  forall a b.
    (Eq a) => (Rbt Integer [(a, Tree b)],
                (([a], [a]),
                  (Rbt Integer [(Ta_rule a b, Nat.Nat)], Maybe a))) ->
                Bool;
brec_cond = (\ (_, (w, (_, qwit))) -> not (fifo_isEmpty w) && is_none qwit);

brec_construct_witness ::
  forall a b.
    (Eq a, Hashable a,
      Hashable b) => Rbt Integer [(a, Tree b)] -> Ta_rule a b -> Tree b;
brec_construct_witness qm r =
  Node (rhsl r) (mapa (\ q -> the (hm_lookup q qm)) (rhsq r));

brec_inner_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [(a, ())] ->
                       Ta_rule a b ->
                         (Rbt Integer [(a, Tree b)],
                           (([a], [a]),
                             (Rbt Integer [(Ta_rule a b, Nat.Nat)],
                               Maybe a))) ->
                           (Rbt Integer [(a, Tree b)],
                             (([a], [a]),
                               (Rbt Integer [(Ta_rule a b, Nat.Nat)],
                                 Maybe a)));
brec_inner_step qi r =
  (\ (q, (w, (rcm, qwit))) ->
    let {
      c = the (hm_lookup r rcm);
      cond = c <= 1 && is_none (hm_lookup (lhs r) q);
      rcma = hm_update r (c - 1) rcm;
      qa = (if cond then hm_update (lhs r) (brec_construct_witness q r) q
             else q);
      wa = (if cond then fifo_put (lhs r) w else w);
      qwita = (if c <= 1 && hs_memb (lhs r) qi then Just (lhs r) else qwit);
    } in (qa, (wa, (rcma, qwita))));

brec_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [(a, [Ta_rule a b])] ->
                       Rbt Integer [(a, ())] ->
                         (Rbt Integer [(a, Tree b)],
                           (([a], [a]),
                             (Rbt Integer [(Ta_rule a b, Nat.Nat)],
                               Maybe a))) ->
                           (Rbt Integer [(a, Tree b)],
                             (([a], [a]),
                               (Rbt Integer [(Ta_rule a b, Nat.Nat)],
                                 Maybe a)));
brec_step rqrm qi =
  (\ (q, (w, (rcm, qwit))) ->
    let {
      (qa, wa) = fifo_get w;
    } in ls_iterate (brec_inner_step qi) (rqrm_lookup rqrm qa)
           (q, (wa, (rcm, qwit))));

hta_empty :: forall a b. (Hashable a, Hashable b) => HashedTa_ext_type a b ();
hta_empty = init_hta hs_empty ls_empty;

ls_image :: forall a b. (Eq b) => (a -> b) -> [a] -> [b];
ls_image = iflt_image ls_image_filter;

hta_remap ::
  forall a b c.
    (Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => (a -> b) ->
                       HashedTa_ext_type a c () -> HashedTa_ext_type b c ();
hta_remap f h =
  init_hta (hs_image f (hta_Qi h)) (ls_image (remap_rule f) (hta_delta h));

ls_union_dj :: forall a. [a] -> [a] -> [a];
ls_union_dj s1 s2 = revg s1 s2;

hashcode_of_usw ::
  forall a b. (Hashable a, Hashable b) => Ustate_wrapper a b -> Integer;
hashcode_of_usw (USW1 q) = hashcode q;
hashcode_of_usw (USW2 q) = hashcode q;

hashcode_ustate_wrapper ::
  forall a b. (Hashable a, Hashable b) => Ustate_wrapper a b -> Integer;
hashcode_ustate_wrapper = hashcode_of_usw;

instance (Hashable a, Hashable b) => Hashable (Ustate_wrapper a b) where {
  hashcode = hashcode_ustate_wrapper;
};

eq_ustate_wrapper ::
  forall a b. (Eq a, Eq b) => Ustate_wrapper a b -> Ustate_wrapper a b -> Bool;
eq_ustate_wrapper (USW1 q1a) (USW1 q1) = q1a == q1;
eq_ustate_wrapper (USW2 q2a) (USW2 q2) = q2a == q2;
eq_ustate_wrapper (USW1 q1) (USW2 q2) = False;
eq_ustate_wrapper (USW2 q2) (USW1 q1) = False;

instance (Eq a, Eq b) => Eq (Ustate_wrapper a b) where {
  a == b = eq_ustate_wrapper a b;
};

hta_union ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext_type a b () ->
                       HashedTa_ext_type c b () ->
                         HashedTa_ext_type (Ustate_wrapper a c) b ();
hta_union h1 h2 =
  init_hta (hs_union (hs_image USW1 (hta_Qi h1)) (hs_image USW2 (hta_Qi h2)))
    (ls_union_dj (ls_image (remap_rule USW1) (hta_delta h1))
      (ls_image (remap_rule USW2) (hta_delta h2)));

list_to_ls :: forall a. (Eq a) => [a] -> [a];
list_to_ls = remdups;

rule_states_l :: forall a b. (Eq a) => Ta_rule a b -> [a];
rule_states_l (Rule q f qs) = ls_ins q (list_to_ls qs);

it_Union_image ::
  forall a b c d.
    ((a -> b -> b) -> c -> b -> b) -> b -> (d -> b -> b) -> (a -> d) -> c -> b;
it_Union_image it1 em3 un233 f s = it1 (\ x -> un233 (f x)) s em3;

llh_Union_image ::
  forall a b. (Eq b, Hashable b) => (a -> [b]) -> [a] -> Rbt Integer [(b, ())];
llh_Union_image = it_Union_image ls_iterate hs_empty lhh_union;

hta_delta_states ::
  forall a b c.
    (Eq a, Hashable a) => HashedTa_ext_type a b c -> Rbt Integer [(a, ())];
hta_delta_states h =
  llh_Union_image id
    (ls_image_filter (\ r -> Just (rule_states_l r)) (hta_delta h));

hta_states ::
  forall a b c.
    (Eq a, Hashable a) => HashedTa_ext_type a b c -> Rbt Integer [(a, ())];
hta_states h = hs_union (hta_Qi h) (hta_delta_states h);

hh_map_to_nat ::
  forall a.
    (Eq a, Hashable a) => Rbt Integer [(a, ())] -> Rbt Integer [(a, Nat.Nat)];
hh_map_to_nat = map_to_nat hs_iterate hm_empty hm_update;

hta_reindex ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext_type a b () -> HashedTa_ext_type Nat.Nat b ();
hta_reindex h =
  let {
    mp = hh_map_to_nat (hta_states h);
  } in hta_remap (\ q -> the (hm_lookup q mp)) h;

htai_prod ::
  HashedTa_ext_type Nat.Nat Nat.Nat () ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_prod h1 h2 = hta_reindex (hta_prod h1 h2);

length_unique :: forall a. (Eq a) => [a] -> Nat.Nat;
length_unique [] = 0;
length_unique (x : xs) =
  (if member xs x then length_unique xs else suc (length_unique xs));

rs_iterate :: forall a b. (Linorder a) => (a -> b -> b) -> Rbt a () -> b -> b;
rs_iterate = s_iterate rm_iterate;

rs_size :: forall a. (Linorder a) => Rbt a () -> Nat.Nat;
rs_size = it_size rs_iterate;

it_set_to_fifo ::
  forall a b.
    ((a -> ([a], [a]) -> ([a], [a])) -> b -> ([a], [a]) -> ([a], [a])) ->
      b -> ([a], [a]);
it_set_to_fifo iteratea s = iteratea fifo_put s fifo_empty;

hs_to_fifo :: forall a. (Hashable a) => Rbt Integer [(a, ())] -> ([a], [a]);
hs_to_fifo = it_set_to_fifo hs_iterate;

build_rqrm ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => [Ta_rule a b] -> Rbt Integer [(a, [Ta_rule a b])];
build_rqrm delta =
  ls_iterate (\ r res -> foldla (\ resa q -> rqrm_add q r resa) res (rhsq r))
    delta hm_empty;

hta_add_qi ::
  forall a b.
    (Eq a, Hashable a,
      Hashable b) => a -> HashedTa_ext_type a b () -> HashedTa_ext_type a b ();
hta_add_qi qi h = init_hta (hs_ins qi (hta_Qi h)) (hta_delta h);

lll_inj_image_filter_cp ::
  forall a b c. (a -> b -> c) -> (a -> b -> Bool) -> [a] -> [b] -> [c];
lll_inj_image_filter_cp =
  inj_image_filter_cp ls_iterate ls_iterate ls_empty ls_ins_dj;

delta_prod_h ::
  forall a b c.
    (Hashable a, Eq b, Hashable b,
      Hashable c) => [Ta_rule a b] -> [Ta_rule c b] -> [Ta_rule (a, c) b];
delta_prod_h delta_1 delta_2 =
  lll_inj_image_filter_cp r_prod
    (\ r1 r2 ->
      rhsl r1 == rhsl r2 && size_list (rhsq r1) == size_list (rhsq r2))
    delta_1 delta_2;

hta_prodWR ::
  forall a b c d e.
    (Eq a, Hashable a, Eq b, Hashable b, Eq d,
      Hashable d) => HashedTa_ext_type a b c ->
                       HashedTa_ext_type d b e -> HashedTa_ext_type (a, d) b ();
hta_prodWR h1 h2 =
  init_hta (hhh_cart (hta_Qi h1) (hta_Qi h2))
    (delta_prod_h (hta_delta h1) (hta_delta h2));

hta_reduce ::
  forall a b c.
    (Eq a, Hashable a,
      Eq b) => HashedTa_ext_type a b c ->
                 Rbt Integer [(a, ())] -> HashedTa_ext_type a b ();
hta_reduce h q =
  init_hta (hs_inter q (hta_Qi h))
    (ls_image_filter
      (\ r ->
        (if hs_memb (lhs r) q && list_all (\ qa -> hs_memb qa q) (rhsq r)
          then Just r else Nothing))
      (hta_delta h));

htai_empty :: HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_empty = hta_empty;

htai_union ::
  HashedTa_ext_type Nat.Nat Nat.Nat () ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_union h1 h2 = hta_reindex (hta_union h1 h2);

ls_size :: forall a. [a] -> Nat.Nat;
ls_size = it_size ls_iterate;

brc_rcm_init ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => [Ta_rule a b] -> Rbt Integer [(Ta_rule a b, Nat.Nat)];
brc_rcm_init delta =
  ls_iterate (\ r -> hm_update r (length_unique (rhsq r))) delta hm_empty;

brc_initial ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => [Ta_rule a b] ->
                       (Rbt Integer [(a, ())],
                         ([a], Rbt Integer [(Ta_rule a b, Nat.Nat)]));
brc_initial delta =
  let {
    iq = brc_iq delta;
  } in (iq, (hs_to_list iq, brc_rcm_init delta));

htai_add_qi ::
  Nat.Nat ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_add_qi = hta_add_qi;

htai_prodWR ::
  HashedTa_ext_type Nat.Nat Nat.Nat () ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_prodWR h1 h2 = hta_reindex (hta_prodWR h1 h2);

sel_disjoint_witness ::
  forall a b c d. (a -> (b -> Maybe b) -> c) -> (b -> d -> Bool) -> a -> d -> c;
sel_disjoint_witness sel1 mem2 s1 s2 =
  sel1 s1 (\ x -> (if mem2 x s2 then Just x else Nothing));

hh_disjoint_witness ::
  forall a.
    (Eq a,
      Hashable a) => Rbt Integer [(a, ())] -> Rbt Integer [(a, ())] -> Maybe a;
hh_disjoint_witness = sel_disjoint_witness hs_sel hs_memb;

brec_initial ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Rbt Integer [(a, ())] ->
                       [Ta_rule a b] ->
                         (Rbt Integer [(a, Tree b)],
                           (([a], [a]),
                             (Rbt Integer [(Ta_rule a b, Nat.Nat)], Maybe a)));
brec_initial qi delta =
  let {
    iq = brc_iq delta;
  } in (brec_iqm delta,
         (hs_to_fifo iq, (brc_rcm_init delta, hh_disjoint_witness iq qi)));

hta_add_rule ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Ta_rule a b ->
                       HashedTa_ext_type a b () -> HashedTa_ext_type a b ();
hta_add_rule r h = init_hta (hta_Qi h) (ls_ins r (hta_delta h));

htai_add_rule ::
  Ta_rule Nat.Nat Nat.Nat ->
    HashedTa_ext_type Nat.Nat Nat.Nat () ->
      HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_add_rule = hta_add_rule;

hta_bwd_reduce ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext_type a b c -> HashedTa_ext_type a b ();
hta_bwd_reduce h =
  let {
    rqrm = build_rqrm (hta_delta h);
  } in hta_reduce h
         (fst (while brc_cond (brc_step rqrm) (brc_initial (hta_delta h))));

htai_bwd_reduce ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_bwd_reduce = hta_bwd_reduce;

htai_ensure_idx_f ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_ensure_idx_f = hta_ensure_idx_f;

htai_ensure_idx_s ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_ensure_idx_s = hta_ensure_idx_s;

htai_ensure_idx_sf ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> HashedTa_ext_type Nat.Nat Nat.Nat ();
htai_ensure_idx_sf = hta_ensure_idx_sf;

hta_is_empty_witness ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext_type a b c -> Maybe (Tree b);
hta_is_empty_witness h =
  let {
    rqrm = build_rqrm (hta_delta h);
  } in (case while brec_cond (brec_step rqrm (hta_Qi h))
               (brec_initial (hta_Qi h) (hta_delta h))
         of {
         (q, (_, (_, Nothing))) -> Nothing;
         (q, (_, (_, Just qa))) -> hm_lookup qa q;
       });

htai_is_empty_witness ::
  HashedTa_ext_type Nat.Nat Nat.Nat () -> Maybe (Tree Nat.Nat);
htai_is_empty_witness = hta_is_empty_witness;

}
